using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Actions;
using DevExpress.Xpo;
using Xafari.BC;
using Xafari.BC.Numerators;
using Xafari.BC.Services;
using Xafari.BC.Settings;

namespace CustomXafariService.Module
{
	// For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/clsDevExpressExpressAppViewControllertopic.
	public partial class ViewController1 : ViewController
	{
		public ViewController1()
		{
			InitializeComponent();
			// Target required Views (via the TargetXXX properties) and create their Actions.
		}
		protected override void OnActivated()
		{
			base.OnActivated();
			// Perform various tasks depending on the target View.
		}
		protected override void OnViewControlsCreated()
		{
			base.OnViewControlsCreated();
			// Access and customize the target View control.
		}
		protected override void OnDeactivated()
		{
			// Unsubscribe from previously subscribed events and release other references and resources.
			base.OnDeactivated();
		}

		private void simpleAction1_Execute(object sender, SimpleActionExecuteEventArgs e)
		{
			this.ObjectSpace.Xafari().DataAccessor.CustomService().ServiceMethod();
			this.ObjectSpace.CommitChanges();

			using (var uow = new UnitOfWork())
			{
				uow.Xafari().DataAccessor.CustomService().ServiceMethod();
				uow.CommitChanges();
			}
		}

		private void simpleAction2_Execute(object sender, SimpleActionExecuteEventArgs e)
		{
			using (var objectSpace = this.Application.CreateObjectSpace())
			{
				using (var serviceSpace = objectSpace.ServiceSpace())
				{
					// any code
					serviceSpace.CommitChanges();
				}
				using (var serviceSpace = objectSpace.ServiceSpace())
				{
					// any code
					serviceSpace.Rollback();
				}
			}
		}

		private void simpleAction3_Execute(object sender, SimpleActionExecuteEventArgs e)
		{
			#region Scenario Same ObjectSpace
			// apply numenrators now
			this.ObjectSpace.ApplyNumerators(this.View.CurrentObject, ApplyNumeratorsStrategy.AfterCreate);
			// apply numerators on save
			this.ObjectSpace.ApplyNumerators(this.View.CurrentObject);
			// apply all delayed numerators
			this.ObjectSpace.CommitChanges();

			// rollback all numerator operations
			this.ObjectSpace.RollbackNumerators(this.View.CurrentObject);
			#endregion

			#region Scenario Own ObjectSpace
			using (var objectSpace = this.Application.CreateObjectSpace())
			{
				// apply numenrators now
				objectSpace.ApplyNumerators(this.View.CurrentObject, ApplyNumeratorsStrategy.AfterCreate);
				// apply numerators on save
				objectSpace.ApplyNumerators(this.View.CurrentObject);
				// apply all delayed numerators, CurrentObject not commited
				objectSpace.CommitChanges();

				// rollback all numerator operations
				objectSpace.RollbackNumerators(this.View.CurrentObject);
			}
			#endregion
		}

		private void simpleAction4_Execute(object sender, SimpleActionExecuteEventArgs e)
		{
			// get root slice
			var rootSlice = this.ObjectSpace.AppSettings().RootSlice;
			// get current slice
			var currentSlice = this.ObjectSpace.AppSettings().CurrentSlice;

			// get settings root node for current slice
			var rootCurrentSlice = this.ObjectSpace.AppSettings().Root();
			// or
			rootCurrentSlice = this.ObjectSpace.AppSettings().CurrentSlice.RootSettings;
			// get settings root node for root slice
			var root = this.ObjectSpace.AppSettings().RootSlice.RootSettings;
		}
	}
}
